Index: /trunk/src/sys/arch/mips/include/pmap.h
===================================================================
--- /trunk/src/sys/arch/mips/include/pmap.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/pmap.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: pmap.h,v 1.54.26.13 2010/05/04 17:15:53 matt Exp $	*/
+/*	$NetBSD: pmap.h,v 1.54.26.18 2011/04/29 08:26:21 matt Exp $	*/
 
 /*
@@ -75,4 +75,8 @@
 #define	_MIPS_PMAP_H_
 
+#ifdef _KERNEL_OPT
+#include "opt_multiprocessor.h"
+#endif
+
 #include <mips/cpuregs.h>	/* for KSEG0 below */
 //#include <mips/pte.h>
@@ -103,9 +107,16 @@
 #define mips_round_seg(x)	(((vaddr_t)(x) + SEGOFSET) & ~SEGOFSET)
 
+#ifdef _LP64
+#define PMAP_SEGTABSIZE		NSEGPG
+#else
 #define PMAP_SEGTABSIZE		(1 << (31 - SEGSHIFT))
+#endif
 
 union pt_entry;
 
-struct segtab {
+union segtab {
+#ifdef _LP64
+	union segtab	*seg_seg[PMAP_SEGTABSIZE];
+#endif
 	union pt_entry	*seg_tab[PMAP_SEGTABSIZE];
 };
@@ -136,6 +147,6 @@
 	uintptr_t);
 void pmap_segtab_activate(struct pmap *, struct lwp *);
-void pmap_segtab_alloc(struct pmap *);
-void pmap_segtab_free(struct pmap *);
+void pmap_segtab_init(struct pmap *);
+void pmap_segtab_destroy(struct pmap *);
 #endif /* _KERNEL */
 
@@ -165,5 +176,5 @@
 	volatile u_int		pm_shootdown_pending;
 #endif
-	struct segtab		*pm_segtab;	/* pointers to pages of PTEs */
+	union segtab		*pm_segtab;	/* pointers to pages of PTEs */
 	u_int			pm_count;	/* pmap reference count */
 	u_int			pm_flags;
@@ -207,7 +218,7 @@
 #define tlbinfo_index(ti)	(0)
 #endif
+	struct evcnt ti_evcnt_asid_reinits;
 	u_long ti_asid_bitmap[256 / (sizeof(u_long) * 8)];
 };
-
 
 #ifdef	_KERNEL
@@ -255,11 +266,11 @@
 #endif
 void	pmap_tlb_info_init(struct pmap_tlb_info *);
+void	pmap_tlb_info_evcnt_attach(struct pmap_tlb_info *);
 void	pmap_tlb_asid_acquire(pmap_t pmap, struct lwp *l);
 void	pmap_tlb_asid_deactivate(pmap_t pmap);
+void	pmap_tlb_asid_check(void);
 void	pmap_tlb_asid_release_all(pmap_t pmap);
 int	pmap_tlb_update_addr(pmap_t pmap, vaddr_t, uint32_t, bool);
 void	pmap_tlb_invalidate_addr(pmap_t pmap, vaddr_t);
-
-uint16_t pmap_pvlist_lock(struct vm_page *, bool);
 
 /*
@@ -304,4 +315,6 @@
 #endif
 
+uint16_t pmap_pvlist_lock(struct vm_page_md *, bool);
+
 #endif	/* _KERNEL */
 #endif	/* _MIPS_PMAP_H_ */
Index: /trunk/src/sys/arch/mips/include/proc.h
===================================================================
--- /trunk/src/sys/arch/mips/include/proc.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/proc.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: proc.h,v 1.21.36.8 2010/05/15 20:27:48 matt Exp $	*/
+/*	$NetBSD: proc.h,v 1.21.36.10 2011/04/29 08:26:22 matt Exp $	*/
 
 /*
@@ -54,9 +54,8 @@
 #endif
 	int	md_flags;		/* machine-dependent flags */
-	int	md_upte[UPAGES];	/* ptes for mapping u page */
 	vaddr_t	md_ss_addr;		/* single step address for ptrace */
 	int	md_ss_instr;		/* single step instruction for ptrace */
-	volatile u_int md_astpending;	/* AST pending on return to userland */
-	register_t md_tinfo;		/* thread info (TLS) */
+	volatile int md_astpending;	/* AST pending on return to userland */
+	int	md_upte[USPACE/4096];	/* ptes for mapping u page */
 };
 
@@ -71,8 +70,12 @@
 
 #ifdef _KERNEL
+struct lwp;
+
 /* kernel single-step emulation */
-int mips_singlestep(struct lwp *l);
+int	mips_singlestep(struct lwp *);
 
 #define	LWP0_CPU_INFO	&cpu_info_store	/* staticly set in lwp0 */
+
+#define	fpu_used_p(l)	(((l)->l_md.md_flags & MDP_FPUSED) != 0)
 #endif /* _KERNEL */
 
Index: /trunk/src/sys/arch/mips/include/sysarch.h
===================================================================
--- /trunk/src/sys/arch/mips/include/sysarch.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/sysarch.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sysarch.h,v 1.8.96.1 2010/05/15 20:27:48 matt Exp $ */
+/*	$NetBSD: sysarch.h,v 1.8.96.2 2011/04/29 08:26:22 matt Exp $ */
 
 #ifndef _MIPS_SYSARCH_H_
@@ -9,5 +9,4 @@
 #define MIPS_CACHEFLUSH	0
 #define MIPS_CACHECTL	1
-#define MIPS_TINFOSET	2
 
 struct mips_cacheflush_args {
Index: /trunk/src/sys/arch/mips/include/trap.h
===================================================================
--- /trunk/src/sys/arch/mips/include/trap.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/trap.h	(revision 152)
@@ -1,5 +1,6 @@
-/*	$NetBSD: trap.h,v 1.15 2005/12/11 12:18:09 christos Exp $	*/
+/*	$NetBSD: trap.h,v 1.15.96.1 2011/04/29 08:26:22 matt Exp $	*/
 
 /*
+ * Copyright (c) 1988 University of Utah.
  * Copyright (c) 1992, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -37,43 +38,4 @@
  *	@(#)trap.h	8.1 (Berkeley) 6/10/93
  */
-/*
- * Copyright (c) 1988 University of Utah.
- *
- * This code is derived from software contributed to Berkeley by
- * the Systems Programming Group of the University of Utah Computer
- * Science Department and Ralph Campbell.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- *
- * from: Utah Hdr: trap.h 1.1 90/07/09
- *
- *	@(#)trap.h	8.1 (Berkeley) 6/10/93
- */
 
 /*
@@ -81,4 +43,6 @@
  * also known in trap.c for name strings
  */
+#ifndef _MIPS_TRAP_H_
+#define _MIPS_TRAP_H_
 
 #define T_INT			0	/* Interrupt pending */
@@ -106,2 +70,8 @@
 
 #define	T_USER			0x20	/* user-mode flag or'ed with type */
+
+#if defined(_KERNEL) && !defined(_LOCORE)
+extern const char * const trap_names[];
+#endif
+
+#endif /* _MIPS_TRAP_H_ */
Index: /trunk/src/sys/arch/mips/include/types.h
===================================================================
--- /trunk/src/sys/arch/mips/include/types.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/types.h	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: types.h,v 1.43.36.15 2010/02/28 23:45:07 matt Exp $	*/
+/*	$NetBSD: types.h,v 1.43.36.17 2011/04/29 08:26:22 matt Exp $	*/
 
 /*-
@@ -54,7 +54,7 @@
 typedef __uint64_t	paddr_t;
 typedef __uint64_t	psize_t;
-#define PRIxPADDR	PRIx64
-#define PRIxPSIZE	PRIx64
-#define PRIdPSIZE	PRId64
+#define	PRIxPADDR	PRIx64
+#define	PRIxPSIZE	PRIx64
+#define	PRIdPSIZE	PRId64
 #else
 #ifndef _STANDALONE
@@ -63,20 +63,20 @@
 typedef __uint32_t	paddr_t;
 typedef __uint32_t	psize_t;
-#define PRIxPADDR	PRIx32
-#define PRIxPSIZE	PRIx32
-#define PRIdPSIZE	PRId32
+#define	PRIxPADDR	PRIx32
+#define	PRIxPSIZE	PRIx32
+#define	PRIdPSIZE	PRId32
 #endif
 #ifdef _LP64
 typedef __uint64_t	vaddr_t;
 typedef __uint64_t	vsize_t;
-#define PRIxVADDR	PRIx64
-#define PRIxVSIZE	PRIx64
-#define PRIdVSIZE	PRId64
+#define	PRIxVADDR	PRIx64
+#define	PRIxVSIZE	PRIx64
+#define	PRIdVSIZE	PRId64
 #else
 typedef __uint32_t	vaddr_t;
 typedef __uint32_t	vsize_t;
-#define PRIxVADDR	PRIx32
-#define PRIxVSIZE	PRIx32
-#define PRIdVSIZE	PRId32
+#define	PRIxVADDR	PRIx32
+#define	PRIxVSIZE	PRIx32
+#define	PRIdVSIZE	PRId32
 #endif
 #endif
@@ -96,6 +96,6 @@
 typedef __int32_t	mips_reg_t;		/* do not use */
 typedef __uint32_t	mips_ureg_t;		/* do not use */
-#define PRIxREGISTER	PRIx32
-#define PRIxUREGISTER	PRIx32
+#define	PRIxREGISTER	PRIx32
+#define	PRIxUREGISTER	PRIx32
 #else
 typedef __int64_t	register_t;
@@ -105,6 +105,6 @@
 typedef __int64_t	register32_t;
 typedef __uint64_t	uregister32_t;
-#define PRIxREGISTER	PRIx64
-#define PRIxUREGISTER	PRIx64
+#define	PRIxREGISTER	PRIx64
+#define	PRIxUREGISTER	PRIx64
 #endif /* __mips_o32 */
 
@@ -129,5 +129,8 @@
 #endif
 
-typedef	volatile int		__cpu_simple_lock_t;
+typedef __uint64_t		__cpuset_t;
+#define	__CPUSET_MAXNUMCPU	64
+
+typedef	volatile unsigned int	__cpu_simple_lock_t;
 
 #define	__SIMPLELOCK_LOCKED	1
@@ -140,5 +143,10 @@
 #define	__HAVE_SYSCALL_INTERN
 #define	__HAVE_PROCESS_XFPREGS
-#define __HAVE_MD_CPU_OFFLINE
+#define	__HAVE_CPU_LWP_SETPRIVATE
+#define	__HAVE_MD_CPU_OFFLINE
+#define	__HAVE_COMMON___TLS_GET_ADDR
+#define	__HAVE___LWP_GETTCB_FAST
+#define	__HAVE___LWP_SETTCB
+#define	__HAVE_TLS_VARIANT_I
 
 #if !defined(__mips_o32)
@@ -148,5 +156,8 @@
 #if defined(_KERNEL)
 #define	__HAVE_RAS
+#if defined(_LP64)
+#define	__HAVE_CPU_VMSPACE_EXEC
 #endif
+#endif /* _KERNEL */
 
 #endif	/* _MACHTYPES_H_ */
Index: /trunk/src/sys/arch/mips/include/vmparam.h
===================================================================
--- /trunk/src/sys/arch/mips/include/vmparam.h	(revision 151)
+++ /trunk/src/sys/arch/mips/include/vmparam.h	(revision 152)
@@ -1,5 +1,6 @@
-/*	$NetBSD: vmparam.h,v 1.41.28.13 2010/03/11 08:19:01 matt Exp $	*/
-
-/*
+/*	$NetBSD: vmparam.h,v 1.41.28.20 2011/04/29 08:26:22 matt Exp $	*/
+
+/*
+ * Copyright (c) 1988 University of Utah.
  * Copyright (c) 1992, 1993
  *	The Regents of the University of California.  All rights reserved.
@@ -37,46 +38,11 @@
  *	@(#)vmparam.h	8.2 (Berkeley) 4/22/94
  */
-/*
- * Copyright (c) 1988 University of Utah.
- *
- * This code is derived from software contributed to Berkeley by
- * the Systems Programming Group of the University of Utah Computer
- * Science Department and Ralph Campbell.
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
- *
- * from: Utah Hdr: vmparam.h 1.16 91/01/18
- *
- *	@(#)vmparam.h	8.2 (Berkeley) 4/22/94
- */
 
 #ifndef _MIPS_VMPARAM_H_
 #define	_MIPS_VMPARAM_H_
+
+#ifdef _KERNEL_OPT
+#include "opt_multiprocessor.h"
+#endif
 
 /*
@@ -97,8 +63,9 @@
  * USRSTACK needs to start a little below 0x8000000 because the R8000
  * and some QED CPUs perform some virtual address checks before the
- * offset is calculated.
- */
-#define	USRSTACK	(VM_MAXUSER_ADDRESS-PAGE_SIZE) /* Start of user stack */
-#define	USRSTACK32	((uint32_t)VM_MAXUSER32_ADDRESS-PAGE_SIZE)
+ * offset is calculated.  We use 0x8000 since that's the max displacement
+ * in an instruction.
+ */
+#define	USRSTACK	(VM_MAXUSER_ADDRESS-0x8000) /* Start of user stack */
+#define	USRSTACK32	((uint32_t)VM_MAXUSER32_ADDRESS-0x8000)
 
 /* alignment requirement for u-area space in bytes */
@@ -108,4 +75,5 @@
  * Virtual memory related constants, all in bytes
  */
+#if defined(__mips_o32)
 #ifndef MAXTSIZ
 #define	MAXTSIZ		(64*1024*1024)		/* max text size */
@@ -123,4 +91,24 @@
 #define	MAXSSIZ		(32*1024*1024)		/* max stack size */
 #endif
+#else
+/*
+ * 64-bit ABIs need more space.
+ */
+#ifndef MAXTSIZ
+#define	MAXTSIZ		(128*1024*1024)		/* max text size */
+#endif
+#ifndef DFLDSIZ
+#define	DFLDSIZ		(256*1024*1024)		/* initial data size limit */
+#endif
+#ifndef MAXDSIZ
+#define	MAXDSIZ		(1536*1024*1024)	/* max data size */
+#endif
+#ifndef	DFLSSIZ
+#define	DFLSSIZ		(16*1024*1024)		/* initial stack size limit */
+#endif
+#ifndef	MAXSSIZ
+#define	MAXSSIZ		(120*1024*1024)		/* max stack size */
+#endif
+#endif /* !__mips_o32 */
 
 /*
@@ -169,9 +157,6 @@
 #define VM_MIN_ADDRESS		((vaddr_t)0x00000000)
 #ifdef _LP64
-#if 1
-#define VM_MAXUSER_ADDRESS	((vaddr_t) 1L << 31)	/* 0x0000000080000000 */
-#else
-#define VM_MAXUSER_ADDRESS	((vaddr_t) 1L << 62)	/* 0x4000000000000000 */
-#endif
+#define VM_MAXUSER_ADDRESS	((vaddr_t) 1L << (4*PGSHIFT-8))
+							/* 0x0000010000000000 */
 #define VM_MAX_ADDRESS		VM_MAXUSER_ADDRESS
 #define VM_MIN_KERNEL_ADDRESS	((vaddr_t) 3L << 62)	/* 0xC000000000000000 */
@@ -205,4 +190,15 @@
 #define	VM_PHYSSEG_NOADD	/* can add RAM after vm_mem_init */
 
+#ifndef VM_NFREELIST
+#define	VM_NFREELIST		16	/* 16 distinct memory segments */
+#define VM_FREELIST_DEFAULT	0
+#define VM_FREELIST_MAX		1
+#endif
+
+#ifdef _KERNEL
+#define	UVM_KM_VMFREELIST	mips_poolpage_vmfreelist
+extern int mips_poolpage_vmfreelist;
+#endif
+
 #define	__HAVE_VM_PAGE_MD
 
@@ -227,10 +223,10 @@
 #define	PG_MD_EXECPAGE		0x0010	/* page is exec mapped */
 
-#define	PG_MD_CACHED_P(pg)	(((pg)->mdpage.pvh_attrs & PG_MD_UNCACHED) == 0)
-#define	PG_MD_UNCACHED_P(pg)	(((pg)->mdpage.pvh_attrs & PG_MD_UNCACHED) != 0)
-#define	PG_MD_MODIFIED_P(pg)	(((pg)->mdpage.pvh_attrs & PG_MD_MODIFIED) != 0)
-#define	PG_MD_REFERENCED_P(pg)	(((pg)->mdpage.pvh_attrs & PG_MD_REFERENCED) != 0)
-#define	PG_MD_POOLPAGE_P(pg)	(((pg)->mdpage.pvh_attrs & PG_MD_POOLPAGE) != 0)
-#define	PG_MD_EXECPAGE_P(pg)	(((pg)->mdpage.pvh_attrs & PG_MD_EXECPAGE) != 0)
+#define	PG_MD_CACHED_P(md)	(((md)->pvh_attrs & PG_MD_UNCACHED) == 0)
+#define	PG_MD_UNCACHED_P(md)	(((md)->pvh_attrs & PG_MD_UNCACHED) != 0)
+#define	PG_MD_MODIFIED_P(md)	(((md)->pvh_attrs & PG_MD_MODIFIED) != 0)
+#define	PG_MD_REFERENCED_P(md)	(((md)->pvh_attrs & PG_MD_REFERENCED) != 0)
+#define	PG_MD_POOLPAGE_P(md)	(((md)->pvh_attrs & PG_MD_POOLPAGE) != 0)
+#define	PG_MD_EXECPAGE_P(md)	(((md)->pvh_attrs & PG_MD_EXECPAGE) != 0)
 
 struct vm_page_md {
@@ -239,42 +235,28 @@
 	volatile u_int pvh_attrs;	/* page attributes */
 	kmutex_t *pvh_lock;		/* pv list lock */
-#define	VM_PAGE_PVLIST_LOCK_INIT(pg) 		\
-	(pg)->mdpage.pvh_lock = NULL
-#define	VM_PAGE_PVLIST_LOCKED_P(pg)		\
-	(mutex_owner((pg)->mdpage.pvh_lock) != 0)
-#define	VM_PAGE_PVLIST_LOCK(pg, list_change)	\
-	pmap_pvlist_lock(pg, list_change)
-#define	VM_PAGE_PVLIST_UNLOCK(pg)		\
-	mutex_spin_exit((pg)->mdpage.pvh_lock);
-#define	VM_PAGE_PVLIST_GEN(pg)		((uint16_t)(pg->mdpage.pvh_attrs >> 16))
+#define	PG_MD_PVLIST_LOCK_INIT(md) 	((md)->pvh_lock = NULL)
+#define	PG_MD_PVLIST_LOCKED_P(md)	(mutex_owner((md)->pvh_lock) != 0)
+#define	PG_MD_PVLIST_LOCK(md, lc)	pmap_pvlist_lock((md), (lc))
+#define	PG_MD_PVLIST_UNLOCK(md)		mutex_spin_exit((md)->pvh_lock)
+#define	PG_MD_PVLIST_GEN(md)		((uint16_t)((md)->pvh_attrs >> 16))
 #else
 	u_int pvh_attrs;		/* page attributes */
-#define	VM_PAGE_PVLIST_LOCK_INIT(pg)	do { } while (/*CONSTCOND*/ 0)
-#define	VM_PAGE_PVLIST_LOCKED_P(pg)	true
-#define	VM_PAGE_PVLIST_LOCK(pg, lc)	(mutex_spin_enter(&pmap_pvlist_mutex), 0)
-#define	VM_PAGE_PVLIST_UNLOCK(pg)	mutex_spin_exit(&pmap_pvlist_mutex)
-#define	VM_PAGE_PVLIST_GEN(pg)		(0)
+#define	PG_MD_PVLIST_LOCK_INIT(md)	do { } while (/*CONSTCOND*/ 0)
+#define	PG_MD_PVLIST_LOCKED_P(md)	true
+#define	PG_MD_PVLIST_LOCK(md, lc)	(mutex_spin_enter(&pmap_pvlist_mutex), 0)
+#define	PG_MD_PVLIST_UNLOCK(md)		mutex_spin_exit(&pmap_pvlist_mutex)
+#define	PG_MD_PVLIST_GEN(md)		(0)
 #endif
 };
 
-#define VM_MDPAGE_INIT(pg)						\
-do {									\
-	(pg)->mdpage.pvh_first.pv_next = NULL;				\
-	(pg)->mdpage.pvh_first.pv_pmap = NULL;				\
-	(pg)->mdpage.pvh_first.pv_va = (pg)->phys_addr;			\
-	VM_PAGE_PVLIST_LOCK_INIT(pg);					\
-	(pg)->mdpage.pvh_attrs = 0;					\
+#define VM_MDPAGE_INIT(pg)					\
+do {								\
+	struct vm_page_md * const md = VM_PAGE_TO_MD(pg);	\
+	(md)->pvh_first.pv_next = NULL;				\
+	(md)->pvh_first.pv_pmap = NULL;				\
+	(md)->pvh_first.pv_va = VM_PAGE_TO_PHYS(pg);		\
+	PG_MD_PVLIST_LOCK_INIT(md);				\
+	(md)->pvh_attrs = 0;					\
 } while (/* CONSTCOND */ 0)
 
-#ifndef VM_NFREELIST
-#define	VM_NFREELIST		16	/* 16 distinct memory segments */
-#define VM_FREELIST_DEFAULT	0
-#define VM_FREELIST_MAX		1
-#endif
-
-#ifdef _KERNEL
-#define	UVM_KM_VMFREELIST	mips_poolpage_vmfreelist
-extern int mips_poolpage_vmfreelist;
-#endif
-
 #endif /* ! _MIPS_VMPARAM_H_ */
